# class Bundler::Plugin::Installer

### Public Instance Methods

install(names, options) click to toggle source

    # File lib/bundler/plugin/installer.rb, line 14
    def install(names, options)
      version = options[:version] || [">= 0"]
      Bundler.settings.temporary(:lockfile_uses_separate_rubygems_sources => false, :disable_multisource => false) do
        if options[:git]
          install_git(names, version, options)
        else
          sources = options[:source] || Bundler.rubygems.sources
          install_rubygems(names, version, sources)
        end
      end
    end

install_definition(definition) click to toggle source

Installs the plugin from `Definition` object created by limited parsing of Gemfile searching for plugins to be installed

@param [Definition] definition object @return [Hash] map of names to their specs they are installed with

    # File lib/bundler/plugin/installer.rb, line 31
    def install_definition(definition)
      def definition.lock(*); end
      definition.resolve_remotely!
      specs = definition.specs

      install_from_specs specs
    end

### Private Instance Methods

install_from_specs(specs) click to toggle source

Installs the plugins and deps from the provided specs and returns map of gems to their paths

@param specs to install

@return [Hash] map of names to the specs

    # File lib/bundler/plugin/installer.rb, line 83
    def install_from_specs(specs)
      paths = {}

      specs.each do |spec|
        spec.source.install spec

        paths[spec.name] = spec
      end

      paths
    end

install_git(names, version, options) click to toggle source

    # File lib/bundler/plugin/installer.rb, line 41
    def install_git(names, version, options)
      uri = options.delete(:git)
      options["uri"] = uri

      source_list = SourceList.new
      source_list.add_git_source(options)

      # To support both sources
      if options[:source]
        source_list.add_rubygems_source("remotes" => options[:source])
      end

      deps = names.map {|name| Dependency.new name, version }

      definition = Definition.new(nil, deps, source_list, true)
      install_definition(definition)
    end

install_rubygems(names, version, sources) click to toggle source

Installs the plugin from rubygems source and returns the path where the plugin was installed

@param [String] name of the plugin gem to search in the source @param [Array] version of the gem to install @param [String, `Array`<String>] source(s) to resolve the gem

@return [Hash] map of names to the specs of plugins installed

    # File lib/bundler/plugin/installer.rb, line 67
    def install_rubygems(names, version, sources)
      deps = names.map {|name| Dependency.new name, version }

      source_list = SourceList.new
      source_list.add_rubygems_source("remotes" => sources)

      definition = Definition.new(nil, deps, source_list, true)
      install_definition(definition)
    end